@use crate::iter::IdentifyLast;
@use crate::templates::base_html;
@use crate::templates::search_icon_html;
@use crate::Urler;
@use crate::limit_description_len;
@use crate::SearchPage;
@use crate::SearchKind;
@use rich_crate::Origin;

@(p: &SearchPage<'_>, url: &Urler)

@:base_html(&p.page(), {

<header id="serp">
    <div class="inner-col">
        @if let SearchKind::Keyword(_) = p.query {
            @:search_icon_html()
        }
        <div class="breadcrumbs">
            <h1><a href="/">Lib.rs</a></h1>
            <span class="categories has-keywords"> ›
            @if let SearchKind::Keyword(_) = p.query {
                Keywords
            }
            @if let SearchKind::Query(_) = p.query {
                Search
            }
            </span>
            @if let Some(k) = Some(p.top_keywords()) {
                @if k.len() > 1 {
                <span class="keywords">
                  <span>
                    @for key in k.iter().take(3) {
                      <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
                    }
                  </span>
                  @for key in k.iter().skip(3).take(5) {
                    <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
                  }
                </span>
                }
            }
        </div>
        @if let SearchKind::Query(query) = p.query {
            <form role="search" id=search method="get" action="/search">
                <input accesskey="s" placeholder="name, keywords, description" autocapitalize="off" autocorrect="off" spellcheck="false"autocomplete="off" tabindex="1" type=search id=search_q value="@query" name=q><button type=submit>Search</button>
            </form>
            @if !p.dym.is_empty() {
                <p>
                    Did you mean @for q in p.dym {
                        <a rel="nofollow" href="@url.search_lib_rs(q)@p.anti_bot_url_suffix()">@q</a>?
                    }
                </p>
            } else {
                @if let Some(iter) = p.alternative_searches() {
                    <p>@query
                        @for (query, label) in iter {
                            <a rel="nofollow" href="@url.search_lib_rs(&query)@p.anti_bot_url_suffix()">…@label</a>?
                        }
                    </p>
                }
            }

            <nav>
                <ul>
                    @if !p.good_results.is_empty() {
                        <li class=active>Sorted by relevance</li>
                    }
                    <li><a href="@url.search_ddg(query)">I'm feeling ducky</a></li>
                </ul>
            </nav>
        }
        @if let SearchKind::Keyword(k) = p.query {
            <h2>#@k</h2>
            <nav>
                <ul>
                    @if !p.good_results.is_empty() {
                        <li class=active>Keyword</li>
                    }
                    <li><a href="@url.search_lib_rs(k)">Search</a></li>
                </ul>
            </nav>
        }
    </div>
</header>
<main id="results">
    <div class="inner-col">
        @if p.good_results.is_empty() {
            <p class=notfound>Nothing found :(</p>
            @if let SearchKind::Query(query) = p.query {
                <p class=tryalso>Try <a href="@url.search_ddg(query)">searching with DuckDuckGo</a> or <a href="@url.search_crates_io(query)">on crates.io</a>.</p>
            }
        } else {
            @if p.nothing_found_without_dym {
                <p class=tryalso>No exact matches found. Showing similar results.</p>
            } else if p.dym_added_fuzzy {
                <p class=tryalso>Exact query did not have good results, added alternative spellings.</p>
            }
            <ol>
            @for (i, c) in p.good_results.iter().chain(p.bad_results).enumerate() {
                <li>
                    <a href="@url.crate_by_origin(&c.origin)"><div class=h>
                        <h4>@if let Some((repo, _)) = c.origin.simple_repo() {@repo.owner/}@c.crate_name</h4>
                        <p class=desc>@p.render_maybe_markdown_str(&limit_description_len(&c.description, 180, 220, &c.crate_name))</p>
                    </div>
                    <div class=meta>
                        <span class="version @p.version_class(&c.version)"><span>@if let Origin::GitHub{..} = c.origin {GitHub } else {v}</span>@c.version</span>
                        @if c.monthly_downloads >= 100 {
                            <span class=downloads title="@c.monthly_downloads recent downloads">@if let Some((num,unit)) = Some(p.downloads(c.monthly_downloads)) {@num<b>@unit</b>}</span>
                        }
                        @for k in c.keywords_normalized() {
                            <span class=k><span>#</span>@k</span>
                        }
                    </div></a>
                </li>
                @if i == p.good_results.len() {
                    @if let SearchKind::Query(query) = p.query {
                        <p class=tryalso>Try <a href="@url.search_ddg(query)">searching with DuckDuckGo</a> or <a href="@url.search_crates_io(query)">on crates.io</a>.</p>
                    }
                    @if let SearchKind::Keyword(query) = p.query {
                        <p class=tryalso>Try <a href="@url.search_ddg(query)">searching with DuckDuckGo</a>.</p>
                    }
                }
            }
            </ol>
        }

        @if let Some(iter) = p.search_also() {
            <p class="tryalso">
                @if let SearchKind::Keyword(_) = p.query {
                    Search for:
                }
                @if let SearchKind::Query(_) = p.query {
                    Narrow the search:
                }
                @for (is_last, (n, (query, label))) in iter.enumerate().identify_last() {
                    <a rel="nofollow" href="@url.search_lib_rs(&query)@p.anti_bot_url_suffix()">@if n == 0 {
                        @if let SearchKind::Keyword(query) = p.query { @query }
                        @if let SearchKind::Query(query) = p.query { @query }
                    } else {…}@label</a>@if !is_last {,}
                }
            </p>
        }
    </div>
</main>

<footer>
    <div class="inner-col">
        <p>Search powered by <a href="https://lib.rs/crates/tantivy">tantivy</a>. The index is a combination of multiple data sources and heuristics, not just pure crate metadata.</p>
        <p>Browse <a href="/">all categories</a>.
    </div>
</footer>
})
